{$I TCIDEF.INC}
Unit T8253;
Interface

Const
  ZQ       = 1193180;
  SpeedDiv = $1111;
  LoopDiv  = $FFFF div SpeedDiv;
  Freq     = ZQ div SpeedDiv; {3.66 ms}

  { --------------- TIMER MODES ----------------- }
  tmStandard = $00; {Don`t overload and break     }
  tmOverLoad = $01; {Auto-overload delay after end}
  tmNotBreak = $02; {Don`t break current loop     }
  tmIsStoped = $80; {Timer is stoped from user    }
  tmRunning  = $7F; {Timer is`nt stoped from user }

Procedure InitTimers;
Procedure DoneTimers;
Function  AddTimer(Delay: Word; User, Param: Pointer; Mode: Byte): Integer; {-1 if error}
Procedure SetTimer(I: Integer; Delay: Word);
Procedure LongTimer(I: Integer; Delta: Word);
Procedure SetUser(I: Integer; User, Param: Pointer);
Procedure SetMode(I: Integer; Mode: Byte);
Procedure DeleteTimer(I: Integer);
Procedure RunTimer(I: Integer);
Procedure StopTimer(I: Integer);
Function  Ready(I: Integer): boolean;
Function  ms2ticks(D: Word): Word;
Function  Ticks2ms(D: Word): Word;
Function  CurrentTicks(I: Integer): Word;
Function  SearchEmulator: Boolean;
Function  T8253Initialazed: Boolean;

Implementation

Type
  TTimer = record
    D, C: Word;
    Mode: Byte;
    User: Pointer;
    case integer of
     0: (PParam: Pointer);
     1: (LParam: Longint);
  end;

Const
  Divider     : Word = 1;
  Counter     : Word = 1;
  TimerSize   = SizeOf(TTimer);
  Busy        : Boolean = false;
  Initialized : Boolean = false;

  Emulator    : Boolean = false;
  GetVec      : Word = $3508;
  SetVec      : Word = $2508;
  Magic       = $8888;

Var
  SaveTimer : Pointer;
  Timers    : array[0..63] of TTimer;
  TimersEnd : record end;

function T8253Initialazed: Boolean;
{}
  begin
    T8253Initialazed := Initialized;
  end; {T8253Initialazed}

procedure TimerInt; assembler;
  asm
  {$IFNDEF PCXT}
        PUSHA
  {$ELSE}
        PUSH    AX
        PUSH    CX
        PUSH    DX
        PUSH    BX
        PUSH    BP
        PUSH    SI
        PUSH    DI
  {$ENDIF}
        PUSH    DS
        PUSH    ES
        MOV     AX, SEG @DATA
        MOV     DS, AX
        CMP     [EMULATOR], TRUE
        JE      @@2
        DEC     [COUNTER]
        JNZ     @@1
        MOV     AX, [DIVIDER]
        MOV     [COUNTER], AX
        PUSHF
        CALL    SAVETIMER
        JMP     @@2
  @@1:  MOV     AL, $20
        OUT     $20, AL
  @@2:  TEST    BUSY,255
        JNZ     @@Q
        INC     BUSY
        STI
        MOV     BX, OFFSET TIMERS
  @@4:  CMP     [BX].TTIMER.C, 0
        JE      @@3
        DEC     [BX].TTIMER.C
        JNZ     @@3
        CMP     WORD PTR [BX].TTIMER.USER+2, 0
        JE      @@3
        PUSH    BX
        PUSH    WORD PTR [BX].TTIMER.LPARAM+2
        PUSH    WORD PTR [BX].TTIMER.LPARAM
        CALL    [BX].TTIMER.USER
        POP     BX
        TEST    [BX].TTIMER.MODE, tmIsStoped
        JNZ     @@3
        TEST    [BX].TTIMER.MODE, tmOverLoad
        JZ      @@3
        CLI
        MOV     CX,[BX].TTIMER.D
        MOV     [BX].TTIMER.C, CX
  @@3:  AND     [BX].TTIMER.MODE, tmRunning
        STI
        ADD     BX, TIMERSIZE
        CMP     BX, OFFSET TIMERSEND
        JB      @@4
        DEC     BUSY
  @@Q:  POP     ES
        POP     DS
  {$IFNDEF PCXT}
        POPA
  {$ELSE}
        POP     DI
        POP     SI
        POP     BP
        POP     BX
        POP     DX
        POP     CX
        POP     AX
  {$ENDIF}
        IRET
  end; {TimerInt}

function SearchEmulator: Boolean; assembler;
{}
  asm
        PUSH    DS
        PUSH    BP
        MOV     CL, 080H
  @@1:  MOV     AH, CL
        MOV     AL, 1
        PUSH    CX
        INT     $2F
        POP     CX
        CMP     AL, $FF
        JNE     @@2
  @@3:  MOV     AL, 1
        CMP     BX, MAGIC
        JNE     @@2
        XOR     BX, DX
        JNZ     @@2
        MOV     AX, SEG @DATA
        MOV     DS, AX
        MOV     GetVec, $358C
        MOV     SetVec, $258C
        MOV     AX, 1
        MOV     Emulator, AL
        JMP     @@Q
  @@2:  ADD     CL, 1
        JNC     @@1
        MOV     AX, SEG @DATA
        MOV     DS, AX
        XOR     AX, AX
        MOV     GetVec, $3508
        MOV     SetVec, $2508
        MOV     Emulator, AL
  @@Q:  POP     BP
        POP     DS
  end; {SearchEmulator}

procedure SetRate(T: Word); near; assembler;
{}
  asm
        CMP     EMULATOR, TRUE
        JE      @@Q
        PUSHF
        CLI
        MOV     AL,  00110110B
        OUT     $43, AL
        MOV     AX,  T
        OUT     $40, AL
        MOV     AL,  AH
        OUT     $40, AL
        POPF
  @@Q:
  end; {SetRate}

procedure InitTimers; assembler;
{}
  asm
        CMP     [INITIALIZED], 1
        JE      @@Q
        MOV     [INITIALIZED], 1
        CALL    SEARCHEMULATOR
        MOV     AX, [GETVEC]
        INT     $21
        MOV     WORD PTR SAVETIMER+2, ES
        MOV     WORD PTR SAVETIMER, BX
        PUSH    DS
        MOV     AX, SETVEC
        MOV     DX, OFFSET TIMERINT
        MOV     BX, CS
        MOV     DS, BX
        INT     $21
        POP     DS
        CMP     [EMULATOR], TRUE
        JE      @@Q
        CLI
        MOV     AX, SpeedDiv
        PUSH    AX
        CALL    SETRATE
        MOV     [DIVIDER], LoopDiv
        STI
  @@Q:
  end; {InitTimers}

procedure DoneTimers; assembler;
{}
  asm
        CLI
        CMP     [INITIALIZED], 0
        JE      @@Q
        CMP     [EMULATOR], TRUE
        JE      @@1
        MOV     AX, $FFFF
        PUSH    AX
        CALL    SETRATE
        MOV     [DIVIDER], 1
        MOV     [COUNTER], 1
  @@1:  PUSH    DS
        MOV     AX, [SETVEC]
        MOV     DX, WORD PTR SAVETIMER
        MOV     DS, WORD PTR SAVETIMER+2
        INT     $21
        POP     DS
        MOV     [INITIALIZED], 0
  @@Q:  STI
  end; {DoneTimers}

function AddTimer(Delay: Word; User, Param: Pointer; Mode: Byte): Integer; assembler;
{}
  asm
        XOR     AX, AX
        MOV     BX, OFFSET TIMERS
        PUSHF
        CLI
  @@2:  CMP     [BX].TTIMER.D, 0
        JE      @@1
        ADD     BX, TIMERSIZE
        INC     AX
        CMP     BX, OFFSET TIMERSEND
        JB      @@2
        MOV     AX, -1
        JMP     @@Q
  @@1:  MOV     CX, DELAY
        MOV     [BX].TTIMER.D, CX
        MOV     CX, WORD PTR USER
        MOV     WORD PTR [BX].TTIMER.USER, CX
        MOV     CX, WORD PTR USER+2
        MOV     WORD PTR [BX].TTIMER.USER+2, CX
        MOV     CX, WORD PTR PARAM
        MOV     WORD PTR [BX].TTIMER.PPARAM, CX
        MOV     CX, WORD PTR PARAM+2
        MOV     WORD PTR [BX].TTIMER.PPARAM+2, CX
        MOV     CL, BYTE PTR MODE
        MOV     BYTE PTR [BX].TTIMER.MODE, CL
  @@Q:  POPF
  end; {AddTimer}

procedure SetTimer(I: Integer; Delay: Word); assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     AX, [DELAY]
        CMP     [BX].TTIMER.C, 0
        JE      @@2
        TEST    [BX].TTIMER.MODE, tmNotBreak
        JNZ     @@3
  @@2:  MOV     [BX].TTIMER.C, AX
  @@3:  MOV     [BX].TTIMER.D, AX
        POPF
  end; {SetTimer}

procedure LongTimer(I: Integer; Delta: Word); assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     AX, [DELTA]
        ADD     [BX].TTIMER.C, AX
        POPF
  end; {SetTimer}

procedure SetUser(I: Integer; User, Param: Pointer); assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, OFFSET TIMERS-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     AX, WORD PTR USER
        MOV     WORD PTR [BX].TTIMER.USER, AX
        MOV     AX, WORD PTR USER+2
        MOV     WORD PTR [BX].TTIMER.USER+2, AX
        MOV     AX, WORD PTR PARAM
        MOV     WORD PTR [BX].TTIMER.PPARAM, AX
        MOV     AX, WORD PTR PARAM+2
        MOV     WORD PTR [BX].TTIMER.PPARAM+2, AX
        POPF
  end; {SetUser}

procedure SetMode(I: Integer; Mode: Byte); assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     AL, MODE
        MOV     [BX].TTIMER.MODE, AL
        POPF
  end; {SetMode}

procedure RunTimer(I: Integer); assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     AX, [BX].TTIMER.D
        MOV     [BX].TTIMER.C, AX
        POPF
  end; {RunTimer}

procedure StopTimer(I: Integer); assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     [BX].TTIMER.C, 0
        OR      [BX].TTIMER.MODE, tmIsStoped
        POPF
  end; {StopTimer}

function Ready(I: Integer): Boolean; assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     AX, [BX].TTIMER.C
        SUB     AX, 1
        MOV     AX, 0
        RCL     AX, 1
        POPF
  end; {Ready}

procedure DeleteTimer(I: Integer); assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        XOR     AX, AX
        MOV     [BX].TTIMER.D, AX
        MOV     [BX].TTIMER.C, AX
        MOV     WORD PTR [BX].TTIMER.USER, AX
        MOV     WORD PTR [BX].TTIMER.USER+2, AX
        POPF
  end; {DeleteTimer}

function Ms2Ticks(D: Word): Word; assembler;
{}
  asm
        MOV     AX, Freq  { FREQ = ZQ div SpeedDiv }
        MUL     D
        MOV     D, 1000
        DIV     D
  end; {Ms2Ticks}

function Ticks2Ms(D: Word): Word; assembler;
{}
  asm
        MOV     AX, 1000
        MUL     D
        MOV     D, Freq
        DIV     D
  end; {Ticks2Ms}

function CurrentTicks(I: Integer): Word; assembler;
{}
  asm
        MOV     CX, I
        INC     CX
        MOV     BX, (OFFSET TIMERS)-TIMERSIZE
        PUSHF
        CLI
  @@1:  ADD     BX, TIMERSIZE
        LOOP    @@1
        MOV     AX, [BX].TTIMER.D
        SUB     AX, [BX].TTIMER.C
        POPF
  end; {CurrentTicks}

var
  SaveExit: Pointer;

procedure ExitTimers; far;
  begin
    ExitProc := SaveExit;
    if Initialized then DoneTimers;
  end;

begin
  FillChar(Timers, SizeOf(Timers), 0);
  SaveExit := ExitProc;
  ExitProc := @ExitTimers;
end.
